package org.jboss.rtgov.elasticsearch.actvity;

import org.overlord.rtgov.activity.model.ActivityType;
import org.overlord.rtgov.activity.model.ActivityUnit;
import org.overlord.rtgov.analytics.service.ResponseTime;
import org.overlord.rtgov.analytics.situation.Situation;

import java.util.Date;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: imk@redhat.com
 * Date: 15/11/13
 * Time: 11:21
 * *  TODO. Create wrapper object here
 *    - last update
 *    - interface name
 *    - conversation id wrapper
 *    - Activity running time
 *    - Complete
 */
//TODO, Add list of properties to add to this unit . will be used for extra information like related response times or situations

public class ElasticActivityUnit extends ActivityUnit {
   private String interfaceName;
   private Date lastUpdate;
    private String conversationID;
    private long txTime;

    public ElasticActivityUnit() {
    }

    public ElasticActivityUnit( String interfaceName,String conversationID) {
        this.conversationID = conversationID;
        this.interfaceName = interfaceName;
    }

    public String getInterfaceName() {
        return interfaceName;
    }

    public void setInterfaceName(String interfaceName) {
        this.interfaceName = interfaceName;
    }

    public Date getLastUpdate() {
        return lastUpdate;
    }

    public void setLastUpdate(Date lastUpdate) {
        this.lastUpdate = lastUpdate;
    }

    public String getConversationID() {
        return conversationID;
    }

    public void setConversationID(String conversationID) {
        this.conversationID = conversationID;
    }

    public long getTxTime() {
        return txTime;
    }

    public void setTxTime(long txTime) {
        this.txTime = txTime;
    }
    public void addActivity(ActivityType t){
        getActivityTypes().add(t);
        this.setLastUpdate(new Date());
    }
    private List<Situation> situations;
    private List<ResponseTime> responseTimes;

    public List<ResponseTime> getResponseTimes() {
        return responseTimes;
    }

    public void setResponseTimes(List<ResponseTime> responseTimes) {
        this.responseTimes = responseTimes;
    }

    public List<Situation> getSituations() {
        return situations;
    }

    public void setSituations(List<Situation> situations) {
        this.situations = situations;
    }
}
