package org.jboss.rtgov.elasticsearch.repo.elastic.impl.api;

import org.elasticsearch.client.Client;
import org.elasticsearch.client.transport.TransportClient;
import org.elasticsearch.common.settings.ImmutableSettings;
import org.elasticsearch.common.settings.Settings;
import org.elasticsearch.common.transport.InetSocketTransportAddress;

/**
 * Created with IntelliJ IDEA.
 * User: imk@redhat.com
 * Date: 09/02/14
 * Time: 13:10
 */
public class ClientFactory {
    private static ClientFactory instance = null;

    public static ClientFactory getInstance() {
        if (instance == null)
            instance = new ClientFactory();

        return instance;

    }

    private Client client;


    public ClientFactory() {
           Settings settings = ImmutableSettings.settingsBuilder().put("client.transport.sniff", true).build();
        client = new TransportClient()
                .addTransportAddress(new InetSocketTransportAddress("localhost", 9300));
    }

    public Client getClient() {
        return client;
    }

}
