package org.jboss.rtgov.elasticsearch.repo.elastic.impl.rest;

import org.codehaus.jackson.map.ObjectMapper;
import org.jboss.resteasy.client.ProxyFactory;
import org.jboss.resteasy.plugins.providers.RegisterBuiltin;
import org.jboss.resteasy.spi.ResteasyProviderFactory;
import org.jboss.rtgov.elasticsearch.repo.ElasticSearchException;
import org.jboss.rtgov.elasticsearch.repo.elastic.ElasticRepo;
import org.overlord.rtgov.activity.util.ActivityUtil;
import org.overlord.rtgov.common.service.Service;

import java.util.logging.Logger;

/**
 * Created with IntelliJ IDEA.
 * User: imk@redhat.com
 * Date: 19/11/13
 * Time: 09:58
 * To change this template use File | Settings | File Templates.
 */
@Deprecated
public abstract  class AbstractElasticRestRepo<D,E,T> extends Service implements ElasticRepo<D,E> {
    Logger logger = Logger.getLogger(AbstractElasticRestRepo.class.getName());
    //todo . Make configurable Elastic Search url.
    protected String ELASTIC_UL="http://localhost:9200";
     // Todo the type should come from the message been sent. Decided to take this from property "interfaceName"
    protected static String ELASTIC_ACTIVITY_TYPE="activity";
    protected static String ELASTIC_SITUATION_TYPE="situation";
    public  T client;
    protected ObjectMapper MAPPER = null;
    protected  abstract Class<T> getRestClientClassImpl();
    @Override
    public void init() throws Exception {
        super.init();
        MAPPER = new ObjectMapper();

        try {
            // this initialization only needs to be done once per VM
            RegisterBuiltin.register(ResteasyProviderFactory.getInstance());
            client = ProxyFactory.create(getRestClientClassImpl(), ELASTIC_UL);
        } catch (Exception e) {
            throw new ElasticSearchException(e.toString(), e);
        }
    }
      protected  String convertTypeToJson(E obj) throws  ElasticSearchException{
          try {
              return ActivityUtil.objectToJSONString(obj);

          } catch (Exception e) {
              throw new  ElasticSearchException("Failed to convert from object to json String [class:"+obj.getClass().getName()+"]", e);
          }
      }


}
