package org.jboss.rtgov.elasticsearch.repo.elastic.impl.rest;

import org.jboss.rtgov.elasticsearch.actvity.ElasticActivityUnit;

import javax.ws.rs.*;
// todo define generic toplevel interface that exposes simple document based getters and setters

public interface ActivityRest {


    @PUT
    @Path("/{index}/activity/{id}")
    @Consumes("application/json")
    org.jboss.resteasy.client.ClientResponse<String> persistEvent(@PathParam("index") String index,
                                                                  @PathParam("id") String id,
                                                                  String body);

    @PUT
    @Path("/{index}/activity/{id}")
    @Consumes("application/json")
    org.jboss.resteasy.client.ClientResponse<String> saveElasticActivityUnit(@PathParam("index") String index,
                                                                             @PathParam("id") String id,
                                                                             ElasticActivityUnit body);


    @GET
    @Path("/{index}/activity/{dynamicpath}")
    @Produces("application/json")
    org.jboss.resteasy.client.ClientResponse<String> getElasticActivityUnit(@PathParam("index") String index, @PathParam("dynamicpath") String param);

    @GET
    @Path("matrixParam")
    @Produces("application/json")
    String getMatrixParam(@MatrixParam("param") String param);

    @GET
    @Path("uriParam/{param}")
    @Produces("text/plain")
    int getUriParam(@PathParam("param") int param);
}